module BNFC.Backend.Txt2Tags.Options where

import BNFC.Prelude

import Options.Applicative

newtype Txt2TagsBackendOptions = TxtOpts {target :: String}

txt2tagsOptionsParser :: Parser Txt2TagsBackendOptions
txt2tagsOptionsParser = TxtOpts <$> oTarget

  where

  -- target option.
  oTarget =
    strOption
      ( short 't'
      <> long "target"
      <> metavar "TARGET"
      <> help "Set txt2tags target document type (for the Makefile)"
      <> showDefault
      <> value "html"
      )
