-- | Entrypoint for the LBNF checker.

{-# LANGUAGE NoImplicitPrelude #-}

module BNFC.Check.Run where

import BNFC.Prelude
import BNFC.CF

import qualified BNFC.Abs as A

import BNFC.Check.Monad
import qualified BNFC.Check.Pass1 as Pass1
import qualified BNFC.Check.Pass2 as Pass2

checkGrammar :: A.Grammar -> (Warnings, RecoverableErrors, Either PFatalError LBNF)
checkGrammar grammar = runCheck $ do
  uncurry Pass2.checkLBNF =<< Pass1.checkLBNF grammar
