module BNFC.Options.Version ( version ) where

import Prelude      ( ($), String, map, show )

import Data.List    ( intercalate )
import Data.Version ( Version(versionBranch) )

import qualified Paths_BNFC3 as Paths

-- | The program version obtained from the cabal file.

version :: String
version = intercalate "." $ map show $ versionBranch Paths.version
