module BNFC.Backend.Agda.State where

import BNFC.CF

import BNFC.Prelude

import BNFC.Options.GlobalOptions

import BNFC.Backend.Agda.Options

import BNFC.Backend.Haskell.Utilities.Utils

data AgdaBackendState = AgdaSt
  { globalOpt :: GlobalOptions
  , agdaOpts :: AgdaBackendOptions
  , lexerParserTokens :: [Token]
  , hsAstRules :: [(Type, [(Label, ([Type], (Integer, ARHS)))])]
  , agdaAstRules :: [(Type, [(Label, [Type])])]
  , parserRules :: [(Cat, Map RHS RuleLabel)]
  , hsFunctions :: [(LabelName,Function)]
  , agdaFunctions :: [(LabelName,Function)]
  , tokens :: [(CatName,TokenDef)]
  }
