module BNFC.Backend.Haskell.State where

import BNFC.CF

import BNFC.Prelude

import BNFC.Options.GlobalOptions

import BNFC.Backend.Haskell.Options

import BNFC.Backend.Haskell.Utilities.Utils

data HaskellBackendState = HaskellSt
  { globalOpt :: GlobalOptions
  , haskellOpts :: HaskellBackendOptions
  , lexerParserTokens :: [Token]
  , astRules :: [(Type, [(Label, ([Type], (Integer, ARHS)))])]
  , parserRules :: [(Cat, Map RHS RuleLabel)]
  , functions :: [(LabelName,Function)]
  , tokens :: [(CatName,TokenDef)]
  }
